# ==================================================================
# Plugins::Bad_Link - Auto Generated Install Module
#
#   Plugins::Bad_Link
#   Author  : UltraNerds.com
#   Version : 2.2.0
#   Updated : Sun Oct  3 18:52:44 2004
#
# ==================================================================
#

package Plugins::Bad_Link;
# ==================================================================
    use strict;
    use vars  qw/$VERSION $DEBUG $NAME $META/;
    use GT::Base;
    use GT::Plugins qw/STOP CONTINUE/;
    use Links qw/$CFG $IN $DB/;

    $VERSION = '2.2.0';
    $DEBUG   = 0;
    $NAME    = 'Bad_Link';
# Inhert from base class for debug and error methods
    @Plugins::Bad_Link::ISA = qw(GT::Base);

    $META = {
    'version' => '2.2.0',
    'url' => 'http://ultranerds.com',
    'prog_ver' => '2.2.0',
    'author' => 'UltraNerds.com',
    'license' => 'Copyrighted',
    'description' => qq|
		#&nbsp;==============================================<BR>
		#&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Bad Link - v. $VERSION<BR>
		#&nbsp;==============================================<BR>
		This is a report bad link script -- to allow users to report links that are bad.<BR>\n
                This version works with Links SQL 2.1.1 and above.
		|,
};


sub pre_install {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they install the plugin.
#
    my $inst_msg = qq|	This will install the Bad_Link script and templates.  
		                It will also create a new table to track bad links.
						<BR>
						<BR>
						This will be the name of the Bad_Link table.:	<input type=text name="table_name" value="Bad_Link">
						<BR>
						<BR>
						After the plug-in installs, check the HELP file for how to set
						up the links _AND_ you must EDIT the options to customize the
						look of certain things.  
					|;

    return $inst_msg;
}

sub pre_uninstall {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they remove the plugin.
#
    my $uninst_msg = '';

    return $uninst_msg;
}

sub install {
# -----------------------------------------------------------------------------
# This function does the actual installation.  Its first argument is a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc.  The second argument is a GT::Tar object which you can use to access any
# files in your plugin module.
#
# You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Bad_Link::error
#
    my ($mgr, $tar) = @_;
	my $error	= '';
	my $message = '';

	use GT::SQL::Creator;
    use GT::SQL::Table;

	my $table_name = $IN->{'table_name'};
	($table_name) || ($table_name = 'Bad_Link');
	my $new_table = $DB->creator('Bad_Link');
	$new_table->cols (
				LinkID		=> { pos => 1, type => 'INT',       size => '11',   not_null => 1, default => 0 },
				URL			=> { pos => 2, type => 'VARCHAR',   size => '150',  not_null => 1 },
				Title		=> { pos => 3, type => 'VARCHAR',   size => '150',  not_null => 1 },
				Status		=> { pos => 4, type => 'VARCHAR',   size => '255',  default  => 'Pending' },
				TimeCheck	=> { pos => 5, type => 'TIMESTAMP', size => '14' },
				IP			=> { pos => 6, type => 'VARCHAR',   size => '15' }
	);
	$new_table->pk ( 'LinkID' );
        $new_table->fk ( { Links => { LinkID => 'ID' } });

	if (! $new_table->create()) { 
		$GT::SQL::errcode ||= ''; #silence -w, ugh.
		$GT::SQL::errcode eq 'TBLEXISTS' ? ($message = "Could not create table <B>$table_name</B> (table already exists)\n") :
										   ($error   = "Could not create table <B>$table_name</B>: $GT::SQL::error)"); 
		$new_table->set_defaults();
		$new_table->save_schema();
	};

# The following section will unarchive attached files into the 
# proper location.
	my $cgi_file_name = 'bad_link.cgi';
    my $file;

####################################################
# Copying bad_link.cgi to user_cgi directory.
    $file = $tar->get_file ($cgi_file_name);
# Get the entire code as a string.
	my $code = $file->body_as_string;
# Replace the path to perl with the users perl.
	$code =~ s/^#!(.*)/#!$CFG->{path_to_perl}/;
# Replace the use lib with the users admin directory.
	$code =~ s/use lib '[^']+'/use lib '$CFG->{admin_root_path}'/;
        $code =~ s,/path/to/links/admin,$CFG->{admin_root_path},g; 
	$file->body ($code);
# Set the name of the file
    $file->name ("$CFG->{admin_root_path}/../bad_link.cgi");
    unless ($file->write) {
        $Plugins::Bad_Link::error = "Unable to extract file: '$CFG->{admin_root_path}/../bad_link.cgi' ($GT::Tar::error)";
        return;
    }
# Set permissions
	chmod (0755, $file->name);

###################################################
# Copying bad_link.html to user_cgi directory.
    $file = $tar->get_file ('bad_link.html');
    $file->name ("$CFG->{admin_root_path}/templates/default/bad_link.html");
    unless ($file->write) {
        $Plugins::Bad_Link::error = "Unable to extract file: '$CFG->{admin_root_path}/templates/default/bad_link.html' ($GT::Tar::error)";
        return;
    }
if ($CFG->{'build_default_tpl'} ne 'default') {
    $file->name ("$CFG->{admin_root_path}/templates/$CFG->{'build_default_tpl'}/bad_link.html");
    unless ($file->write) {
        $Plugins::Bad_Link::error = "Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{'build_default_tpl'}/bad_link.html' ($GT::Tar::error)";
        return;
    }
}


# Set permissions
	chmod (0777, $file->name);   

 	$mgr->install_menu  ( 'Bad_Link', 
							[
							 ['Help', 'admin.cgi?do=plugin&plugin=Bad_Link&func=help'],
							 ['View Reports', 'admin.cgi?do=plugin&plugin=Bad_Link&func=view'],
							 ['Edit Options', 'admin.cgi?do=page&page=plugin_manager.html&plugin_man_do=edit_installed&plugin_name=Bad_Link']
							] 
						); 

	$mgr->install_options ( 'Bad_Link', 
							[ 
							 ['table_name', $table_name, 'This is the name of the table used to store the bad links.']
#							 ['count_recs', '1', 'On to keep track of recc counts, off to ignore'],
#							 ['script_name', 'Bad_Link.cgi', 'If you\'ve changed thename of the scipt, enter it here.'],
#							 ['site_name', 'Your Site Name', 'Name of your site to show visitors.'],
#							 ['site_url', 'http://your_site.name', 'URL of your site to link to the Site Name above.']
							] 
						); 
	
	if ($error) {
		$Plugins::Bad_Link::error = $error;
		return;
	}
	if ($message) {
		return "The plugin has been installed, but there were the following warnings: <br><br>$message";
	}
	return "The plugin has been successfully installed!";
}


sub uninstall {
# -----------------------------------------------------------------------------
# This function removes the plugin.  Its first argument is also a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc. You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Bad_Link::error
#
    my $mgr = shift;

    return "The plugin has been successfully removed!";
}

1;
